#!/bin/perl

#-----------------------------------------------------------
#
# dbn_clean.pl
#
# Distributed Brokered Networking (DBNet) cleanup  perl script
#-----------------------------------------------------------

$dbn_root = $ENV{'DBNROOT'};

if (!defined($dbn_root) || !$dbn_root) {
  print STDERR "\n$0: environment variable DBNROOT not set!\n";
  exit 1;
}

$dbn_config="${dbn_root}/table/dbn_config";
require "$dbn_config";


unshift(@INC, '.');
unshift(@INC, "$include_dir");

require 'dbn_util.pl';

if (!&util'init()) {
  &util'msg($util'ERROR_MSG,"$0: init() failed!");
  exit 1;
}

$dbn_clean_test=shift if @ARGV == 1;
if (defined $dbn_clean_test && $dbn_clean_test eq "test") {
  &util'msg($util'INFO_MSG,"$0: test mode");
  $dbn_clean_test = 1;
  &util'clean_all($clean_table);
  exit $?;
}

open (TMPFILE,">${dbnet_que}/Cleanup");

print TMPFILE "${$}: Cleanup started at " . time;

close(TMPFILE);

&util'clean_all($clean_table);

exit $? ;



