#!/bin/perl

#-----------------------------------------------------------
#
# This program now requires a link to perl v5.002  in the
# DBNROOT/bin directory.  This was done to dependencies on 
# the location of the perl executable.
# Distributed Brokered Networking (DBNet) Queue Handler perl script
#-----------------------------------------------------------

use POSIX "sys_wait_h";
#use Getopt::Std;
use File::Basename;
use File::Path;
use Time::CTime;
# sunos4
#sub WNOHANG { 0 };

#
# package scope
#

$dbn_root="";
$cmdtype_in="";
$cmdtype="";
$qh_run="";
$cmd_pattern="";
@scmds=();
@bscmds=();
%bscmds_path=();
$first_time_load_cmds=0;
$starttime=time;
$currtime=$starttime;
%qh_jmptbl = ();
%busy_cmds = ();
%exec_cmds = ();
%group_cmds = ();
%clnt_cmds = ();
%ftpget_cmds = ();
#
# end of package scope 
#


$dbn_root=$ENV{'DBNROOT'};

if (!defined($dbn_root) || !$dbn_root) {
  print STDERR "\n$0: environment variable DBNROOT not set!\n";
  exit 1;
}

require "${dbn_root}/table/dbn_config";

unshift(@INC, '.');
unshift(@INC, "$include_dir");

require 'dbn_util.pl';
require 'file_scan.pl';

if (!&util'init()) {
  &util'msg($util'ERROR_MSG,"$0: init() failed!");
  exit 1;
}

$cmdtype_in="$qh_all";
$cmdtype_in=shift if @ARGV == 1;

if ( $cmdtype_in eq $qh_all ) {
  $cmdtype="^($clnt|$ldm|$ftpget|$exec|$pipe|$dproc|$group|$file)";
}
elsif ( $cmdtype_in eq $clnt ) {
  $cmtype="^($clnt)";
}
elsif ( $cmdtype_in eq $ldm ) {
  $cmtype="^($ldm)";
}
elsif ( $cmdtype_in eq $ftpget ) {
  $cmtype="^($ftpget)";
}
elsif ( $cmdtype_in eq $exec ) {
  $cmtype="^($exec)";
}
elsif ( $cmdtype_in eq $pipe ) {
  $cmtype="^($pipe)";
}
elsif ( $cmdtype_in eq $file ) {
  $cmtype="^($file)";
}
elsif ( $cmdtype_in eq $dproc ) {
  $cmtype="^($dproc)";
}
else {
  &util'msg($util'ERROR_MSG,"usage: $0 [cmdtype]: $cmdtype");
  exit 1;
}

$qh_run="${qh}.${cmdtype_in}";
exit 1 if ! &util'is_running($tmp_dir, "${qh_run}");

$cmd_pattern="${cmdtype}\\.([\\w]+)\\.([\\w]+)\\.([\\d]+)\\.([\\d]+)\\.([\\d]+)\\.([\\d]+)";
$groupline_pattern = "([\\S]+)[ \\t]+([\\S]+)[ \\t]+([\\S]+)[ \\t]+([\\S]+)[ \\t]+([\\S]+)[ \\t]+([\\S]+)[ \\t]+([\\S]+)[ \\t]+(\.*)";
$commandline_g_pattern = "([\\S]+)[ \\t]+([\\S]+)[ \\t]+([\\S]+)[ \\t]+([\\S]+)[ \\t]+(\.*)";
$commandline_g2_pattern = "([\\S]+)[ \\t]+([\\S]+)[ \\t]+([\\S]+)[ \\t]+([\\S]+)[ \\t]+(\.*)";
$cmd_h_pattern = "([\\S]+)[ \\t]+([\\S]+)[ \\t]*(\.*)";


%qh_jmptbl = (
"$clnt",  '&clnt_hndlr',
"$ldm",   '&ldm_hndlr',
"$ftpget", '&ftpget_hndlr',
"$exec",  '&exec_hndlr',
"$pipe",  '&pipe_hndlr',
"$dproc", '&dproc_hndlr',
"$group", '&group_hndlr',
"$file",  '&file_hndlr',
);



&util'msg($util'INFO_MSG,"$0: entry: cmdtype=${cmdtype} DBNROOT=${dbn_root}");

$purge_time = 0;
$next_file_scan_time = 0;

while (1) {

  $currtime=time;  
  if ( $qh_auto_restart > 0 ) {
    if ( ( $currtime - $starttime ) > $qh_auto_restart ) {
      &util'msg($util'WARN_MSG,"$0: starttime-currtime>qh_auto_restart: $starttime - $currtime > $qh_auto_restart");
      kill 'TERM', $$;
    }
  }
  if ( &util'isit_time_to_die($tmp_dir, "${qh_run}") ) {
    `$0 $cmdtype_in &` if (  ( $qh_auto_restart > 0 ) &&
                            (( $currtime - $starttime ) > $qh_auto_restart ) );
    exit 1;
  }
  if ($purge_time < $currtime) {
    &run_cleanup();
  }
  if ($next_file_scan_time < $currtime) {
    $next_file_scan_time = $currtime + $file_scan_time;
    &scan_dir();
  }

  $dbnet_que = $static_dbnet_que;
  if (! ($dbnet_que=&util'build_timestamped_dbnet_que) ) {
    &util'msg($util'ERROR_MSG,"$0: Cannot create timestamped dbnet_que  directory");
    exit 1;
  }


#&util'msg($util'DEBUG_MSG,"Before Process Pending");
#  &process_pending();
#  &process_foreign();
#&util'msg($util'DEBUG_MSG,"Before load commands");
  &load_cmds();
#&util'msg($util'DEBUG_MSG,"Before dispatch");
  &dispatch();
#&util'msg($util'DEBUG_MSG,"After dispatch");
  sleep $qh_scan_time;
}


sub run_cleanup {
  $purge_time = $currtime + $clean_time;

  foreach (values(%busy_cmds)) {
    if ($_ eq $cleancmd) {
      &util'msg($util'ERROR_MSG,"Cleanup already running, Cannot launch another copy");
      return 0;
    }
  }
  launch("$cleancmd","$clean_prog");    
}


sub load_cmds {
  local(@cmds, $i, $cmdfile, $cpid, $busy_cmdfile);
  local (@subdir, $stamped_subdir);
  my (%busy_cmds_backwards);
  @subdir= "";
#
# if first time, move cmds back into enque area
#
  if ( ! $first_time_load_cmds ) {
    if (!opendir(DIR, "$static_dbnet_que")) {
      &util'msg($util'ERROR_MSG,"$0: opendir($static_dbnet_que) failed: $!");
      kill 'TERM', $$;
      return 0;
    }
    @subdir=readdir (DIR);
    closedir (DIR);

    while (@subdir) {
      $stamped_subdir= shift(@subdir);
      if ($stamped_subdir =~ /^\d{12}$/) {
        if (! opendir (SUBDIR, "${static_dbnet_que}/${stamped_subdir}") ) {
          &util'msg($util'ERROR_MSG,"$0: opendir (${static_dbnet_que}/${stamped_subdir}) failed: $!");
          next;
        }
        @cmds=readdir(SUBDIR);
        closedir(SUBDIR);

        while (@cmds) {
          $cmdfile = shift(@cmds);
          if ($cmdfile =~ /$cmd_pattern/o ) {
            if (! &util'dbn_rename("${static_dbnet_que}/${stamped_subdir}/${cmdfile}", "${dbnet_que_enque}/${cmdfile}")) {
              kill 'TERM', $$;
              return 0;
            }
          }
        }
      }
    }
  
    $first_time_load_cmds=1;
  }

#
# build cmds and move from the enque area
#
  if (!opendir(DIR, $dbnet_que_enque)) {
    &util'msg($util'ERROR_MSG,"$0: opendir($dbnet_que_enque) failed: $!");
    kill 'TERM', $$;
    return 0;
  }

  @cmds=readdir(DIR);
  closedir(DIR);

  for ($i=@cmds; $i > 0; $i--) {
    if ( $cmds[$i-1] =~ /$cmd_pattern/o ) {
      if (! &util'dbn_rename("$dbnet_que_enque/$cmds[$i-1]", "$dbnet_que/$cmds[$i-1]")) {
         kill 'TERM', $$;
         return 0;
      }
      $bscmds_path{$cmds[$i-1]} =  "$dbnet_que/$cmds[$i-1]";
    }
    else {
      splice(@cmds, $i-1, 1);
    }
  }

# build scmds
#

  @scmds=@bscmds;
  for ($i=@scmds; $i > 0; $i--) {
    splice(@scmds, $i-1, 1) if ! -e $bscmds_path{$scmds[$i-1]};
  }
  &util'sort_cmds(\@cmds, "", 0);
  while (@cmds) {
    $cmdfile = shift(@cmds);
    push(@scmds, $cmdfile);
  }
  @bscmds=@scmds;

#
# remove all busy_cmds entries from scmds
# 

  foreach (keys %busy_cmds) {
    $busy_cmds_backwards{$busy_cmds{$_}} = $_;
  }
 
  for ($i=@scmds; $i > 0; $i--) {
      splice(@scmds, $i-1, 1) if defined $busy_cmds_backwards{$scmds[$i-1]} ;
  }
  undef (@cmds);
  return 1;
}

sub fast_scan_sort {
  local($ftime_a, $ftime_b);

  $a =~ /$cmd_pattern/o;
  $ftime_a="${6}${5}${4}";
  $b =~ /$cmd_pattern/o;
  $ftime_b="${6}${5}${4}";
  $ftime_a cmp $ftime_b;
}


sub scan_sort {
  local($cmd_a, $site_a, $msg_a, $fsn_a, $pid_a, $ftime_a);
  local($cmd_b, $site_b, $msg_b, $fsn_b, $pid_b, $ftime_b);

  $a =~ /$cmd_pattern/o;
  $cmd_a=$1, $site_a=$2, $msg_a=$3, $fsn_a=$4, $pid_a=$5, $ftime_a=$6;
  $b =~ /$cmd_pattern/o;
  $cmd_b=$1, $site_b=$2, $msg_b=$3, $fsn_b=$4, $pid_b=$5, $ftime_b=$6;
  $ftime_a <=> $ftime_b;
}

sub dispatch { 
  local($cmd_h, $cpid, @cpids, $scmd, $busy_cmdfile, $datafile, $qarg, @qargs, $err);
  local($desthost);                # used by clnt_handler
#  local($exec_t, $exec_p);         # used by exec_handler 
  local($cmd_a, $site_a, $msg_a, $fsn_a, $pid_a, $ftime_a);
  local($cmd_b, $site_b, $msg_b, $fsn_b, $pid_b, $ftime_b);
  

  $cpid = waitpid(-1,&WNOHANG);

  while ( ($cpid != -1) && ($cpid != 0) ) {
    $err=$?;
    &util'msg($util'INFO_MSG,"$0: $cmdtype_in: dispatch: $cpid = wait: $err");
    $cmd_a = $busy_cmds{$cpid};
    delete $exec_cmds{$cpid};
    if (defined ($group_cmds{$cmd_a})) {
      &process_group($cmd_a,$err,0);
    }
    delete $busy_cmds{$cpid};
    if ( $cmd_a =~ /$cmd_pattern/o ) {
      if ($1 eq $clnt) {
        if ($clnt_cmds{"$2"} == 1) {
          delete $clnt_cmds{"$2"};
        } else {
          $clnt_cmds{"$2"}--;
        }
      } elsif ( $1 eq $ftpget ) {
          #if ($ftpget_cmds{"$2"} == 1) {
          #  delete $ftpget_cmds{"$2"};
          #} else {
            $ftpget_cmds{"$2"}--;
          #}
      }
    }
    if (! defined( $cmd_a )) {
     $cpid = waitpid(-1,&WNOHANG);
     next;
    }  
    if ($err != 0) {
     &util'msg($util'WARN_MSG,"$0: $cmdtype_in: dispatch: $cmd_a failed");
     $cpid = waitpid(-1,&WNOHANG);
     next;
    }
    &util'msg($util'WARN_MSG,"$0: $cmdtype_in: dispatch: $cmd_a successful");
#
# cludge -- need to fix later
#
    if ($cmd_a eq "Cleanup") {
      unlink ("$static_dbnet_que/Cleanup");
    } else {
      
    unlink ("$bscmds_path{$cmd_a}") || 
           &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: dispatch: ulink($bscmds_path{$cmd_a}) failed: $!"); 
    delete $bscmds_path{$cmd_a};
    $cpid = waitpid(-1,&WNOHANG);
    }
  } 

  #while(@scmds) {
  foreach $scmd (@scmds) {
#    $scmd=shift(@scmds);
    $scmd =~ /$cmd_pattern/o;
    $cmd_a=$1, $site_a=$2, $msg_a=$3, $fsn_a=$4, $pid_a=$5, $ftime_a=$6, $exp_timea=$7;
#     ($cmd_a, $site_a, $msg_a, $fsn_a, $pid_a, $ftime_a, $exp_timea) = split(/./,$scmd);
    
    if (($exp_timea != 0) && ($exp_timea < time)) {  # this command has expired, delete it, clean group arrays
      if (defined ($group_cmds{$scmd})) {
        &process_group($scmd,1,1);
      }
      &util'msg($util'WARN_MSG,"$0: $cmdtype_in: dispatch: $scmd expired");
      unlink ("$bscmds_path{$scmd}") || 
              &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: dispatch: ulink($bscmds_path{$scmd}) failed: $!"); 
      delete $bscmds_path{$scmd};
      next;
    }  
    return 1 if &process_table_is_full();
    if (($cmd_a eq $clnt ) && ($clnt_check_busy_table) && ($clnt_cmds{"$site_a"} >= $max_clnt_simul)) {
      #&util'msg($util'DEBUG_MSG,"Skippin");  
      next;
    }
    elsif (($cmd_a eq $ftpget ) && ($ftpget_check_busy_table) && ($ftpget_cmds{"$site_a"} >= $max_ftpget_simul)) {
      #&util'msg($util'DEBUG_MSG,"Skipping");  
      next;
    }
    if ( ! eval $qh_jmptbl{$cmd_a} ) {
      &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: dispatch: ${cmd_a}_hndlr failed: dequeuing $bscmds_path{$scmd}");
      if (defined ($group_cmds{$scmd})) {
        &process_group($scmd,1,1);
      }
      unlink ("$bscmds_path{$scmd}") ||
         &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: dispatch: ulink($bscmds_path{$scmd}) failed: $!");
         delete $bscmds_path{$scmd};
    }
#   &util'msg($util'DEBUG_MSG,"After:" . time );  

  }
}


sub process_group {
  local($cmd,$err,$abortcmd) = @_;
  local($mtype,$mscode, $mode, $name, $msg, $fname, $groupfile, $groupline, $commandline);
  local($lineno,$fretrycount, $sretrycount,@command,$stat,@groupcommands,$nextline);


  undef ( @groupcommands); # make sure it's empty
  
  $groupfile = delete $group_cmds{$cmd};

  ($groupfilename, $lineno, $fretrycount,$sretrycount) = split(/:/,$groupfile);
  
  if (!open(CMD, "< ${dbnet_que}/${groupfilename}")) {
    &util'msg($util'ERROR_MSG,"$0: group_hndlr: open(${dbnet_que}/${groupfilename}) failed: $!");
    delete $busy_cmds{$groupfilename};
    delete $exec_cmds{$groupfilename};
    return 0;
  }

  $groupline= <CMD>;
#  $groupline =~ /([\S]+)[ \t]+([\S]+)[ \t]+([\S]+)[ \t]+([\S]+)[ \t]+([\S]+)[ \t]+([\S]+)[ \t]+(.*)/;
  $groupline =~ /$groupline_pattern/;
  $mtype = $2; $mscode = $3; $mode = $4; $name = $5; $msg=$7; $fname = $8;

  while (<CMD>) {
    chomp;
    push(@groupcommands,$_);
    &util'msg($util'DEBUG_MSG,"$0: process GROUP Handler: cmd=$_");
  }

  close (CMD) || &util'msg($util'ERROR_MSG,"$0: Cannot close file $groupfilename");
  
  if ($lineno > @groupcommands) {
    &util'msg($util'ERROR_MSG,"$0:Group $groupfilename incomplete"); 
    unlink ("${dbnet_que}/${groupfilename}") ||
       &util'msg($util'ERROR_MSG,"$0:Group Abort:  ulink(${dbnet_que}/${groupfilename}) failed: $!");
    delete $busy_cmds{$groupfilename};
    delete $exec_cmds{$groupfilename};
    return 1;
  }

  $groupcommands[$lineno] =~ /$commandline_g2_pattern/;
#  $groupcommands[$lineno] =~ /([\S]+)[ \t]+([\S]+)[ \t]+([\S]+)[ \t]+([\S]+)[ \t]+(.*)/;
  $command[0] = $5;
  if ($err == 0) {
    $rcount = $sretrycount;
    $stat=$3;
  } else {
    $rcount = $fretrycount;
    $stat=$1;
  }

  if ($abortcmd != 0 ) {
    $rcount = 0;
  }

  #now determine if the current command is completed

  if ($rcount == 0) {  # current command is completed 
    &util'msg($util'WARN_MSG,"$0:GCMD Completed: return status = $err");
    if (($err != 0) && ($abortcmd == 0)) {  # if it failed clean up that command
      unlink ("${dbnet_que}/${cmd}") ||
          &util'msg($util'ERROR_MSG,"$0:GCMD Abort:  ulink(${dbnet_que}/${cmd}) failed: $!");
      &load_cmds();
    }

    ($nextstep, $nextline) = split(/:/,$stat);
    if (!defined($nextline)) { 
      $nextline = $lineno +1; 
    }

    if ($nextstep eq "ABORT") {
      &util'msg($util'WARN_MSG,"$0:Group $name, $groupfilename aborted from line $lineno"); 
      delete $busy_cmds{$groupfilename};
      delete $exec_cmds{$groupfilename};
      unlink ("${dbnet_que}/${groupfilename}") ||
         &util'msg($util'ERROR_MSG,"$0:Unable to delete group $name, ulink(${dbnet_que}/${groupfilename}) failed: $!");
      return 0;
    }
      
    if ($nextline > (@groupcommands-1)) {  
      # next line number is greater than the number of commands in the file
      # which means we are completed with this group command.
      &util'msg($util'INFO_MSG,"$0:Group $name, $groupfilename completed"); 
      delete $busy_cmds{$groupfilename};
      delete $exec_cmds{$groupfilename};
      unlink ("${dbnet_que}/${groupfilename}") ||
         &util'msg($util'ERROR_MSG,"$0:Unable to delete group $name, ulink(${dbnet_que}/${groupfilename}) failed: $!");
      return 0;
    }
      
 #     $groupcommands[$nextline] =~ /([\S]+)[ \t]+([\S]+)[ \t]+([\S]+)[ \t]+([\S]+)[ \t]+(.*)/ || die "Bad news" ;

   if (!($groupcommands[$nextline] =~ /([\S]+)[ \t]+([\S]+)[ \t]+([\S]+)[ \t]+([\S]+)[ \t]+(.*)/ )) {
      &util'msg($util'ERROR_MSG,"$0:Group command format error. cmd=$groupcommands[$nextline], file=${groupfilename}");
      &util'dbn_rename ("${dbnet_que}/${groupfilename}","${err}/${groupfilename}") ||
        &util'msg($util'ERROR_MSG,"$0:Unable to rename group $groupfilename, err: $!");
      return 0;
    }


    $sretrycount = $4;
    $fretrycount = $2;
    $command[0] = $5;

    &util'msg($util'INFO_MSG,"GROUP Processor: $fname ");
  
    @a = &util'quecmd(*command,$dbnet_que,$fname,$fname,$parse_table,$msg);

    if (!defined(@a) || (@a == 0)) {
      &util'msg($util'INFO_MSG,"$0:Group $name, $groupfilename failed, deleteing file.");
      delete $busy_cmds{$groupfilename};
      delete $exec_cmds{$groupfilename};
      unlink ("${dbnet_que}/${groupfilename}") ||
         &util'msg($util'ERROR_MSG,"$0:Unable to delete group $name, ulink(${dbnet_que}/${groupfilename}) failed: $!");
      return 0;
    }


    foreach (@a) {
      $group_cmds{$_} = "$groupfilename:$nextline:$fretrycount:$sretrycount";
    }
#    &load_cmds();
  } 
  else {    # rcount <> 0, reque same command
    if ($err != 0) {
      $fretrycount--;
      $group_cmds{$cmd} = "$groupfilename:$lineno:$fretrycount:$sretrycount";
      return 0;
    } 
    else {
      $sretrycount--;
     
      @a = &util'quecmd(*command,$dbnet_que,$fname,$fname,$parse_table,$msg);

      if (!defined(@a) || (@a == 0)) {
        &util'msg($util'INFO_MSG,"$0:Group $name, $groupfilename failed, deleteing file.");
        delete $busy_cmds{$groupfilename};
        delete $exec_cmds{$groupfilename};
        unlink ("${dbnet_que}/${groupfilename}") ||
           &util'msg($util'ERROR_MSG,"$0:Unable to delete group $name, ulink(${dbnet_que}/${groupfilename}) failed: $!");
        return 0;
      }


      foreach (@a) {
        $group_cmds{$_} = "$groupfilename:$lineno:$fretrycount:$sretrycount";
      }
      &load_cmds();
    }
  }
  return 0

}
  
sub clnt_hndlr {
  my($cmd_b,$site_b,$msg_b,$fsn_b,$pid_b,$ftime_b);
  my($dirpath, $fn, $rval);
  my($ifcp_dev_mode);

#  foreach $busy_cmdfile (values %busy_cmds) {
#  while (($cpid, $busy_cmdfile) = each %busy_cmds)  {
#    $busy_cmdfile =~ /$cmd_pattern/o;
#    $cmd_b=$1, $site_b=$2, $msg_b=$3, $fsn_b=$4, $pid_b=$5, $ftime_b=$6;
#    return 1 if ( ( $cmd_a  eq $cmd_b  ) &&
#                  ( $site_a eq $site_b ) &&
#                  ( $msg_a  eq $msg_b  )     ); 
#  }
#  return 1 if defined $clnt_cmds{"$site_a"};

  if (!open(CMD, "< $bscmds_path{$scmd}")) {
    &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: clnt_hndlr: open($bscmds_path{$scmd}) failed: $!");
    return 0;
  }
  $cmd_h=""; 
  while (<CMD>) {
    $cmd_h .= $_;
  }
  close (CMD) || &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: clnt_hndlr: close($bscmds_path{$scmd}) failed: $!");
#  $cmd_h =~ /([\S]+)[ \t]+([\S]+)[ \t]*(.*)/;
  $cmd_h =~ /$cmd_h_pattern/;
  $desthost=$1, $datafile=$2, $qarg=$3;

  if ($desthost =~ /^-F(\S+)/) {
    if (!-r "${tbl_dir}/$1") {
      &util'msg($util'WARN_MSG,"$0: clnt_hndlr:redirection file ${tbl_dir}/$1 is not readable");
      $desthost = $1;
    } else {
      $desthost = `cat ${tbl_dir}/$1`;
      chomp $desthost;
    }
  }

  $ifcp_dev_mode=0;
  if ($qarg =~ /-X(\S*)/) {
    $ifcp_dev_mode=1;
    $qarg =~ s/-X(\S*)//;
  }

    
  

  ($dirpath, $fn)=&util'split_path($datafile);
  if ( ! -r $datafile ) {
    &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: clnt_hndlr: datafile $datafile cannot be read");
    unlink ($datafile) ||
      &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: clnt_hndlr: unlink($datafile) failed: $!");
    return 0;
  }
  $desthost="-r${desthost}";
  $datafile="-m${datafile}";
  @qargs=split(/[ \t]+/, $qarg);
  unshift(@qargs, $desthost);
  unshift(@qargs, $datafile);
  unshift(@qargs, "-e$fn");
  $ifcp_dev_mode ? unshift(@qargs, $IFC_DEV) : unshift(@qargs, $IFC);
  $rval =launch($scmd, @qargs);
  if ($rval == 1) {
    if (defined $clnt_cmds{"$site_a"} ) {
      $clnt_cmds{"$site_a"}++ ;
    } else {
      $clnt_cmds{"$site_a"} = 1;
    }
  }
  return $rval;
}

sub file_hndlr {
  my(@ARGV);
  my($stime) = time;
  my($ttime) = $stime;
  my($i) = 0;
  my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime($stime);
  my($tsec,$tmin,$thour,$tmday,$tmon,$tyear,$twday,$tyday,$tisdst) = gmtime($stime);
  my($wmosec,$wmomin,$wmohour,$wmomday,$wmomon,$wmoyear,$wmowday,$wmoyday,$wmoisdst);
  my($basenm, $dirnm, $imsg);

  $wmo_pattern_1  = '^(\w{5,6})[ ]+(\w{4})[ ]+(\d{6})';

  if (!open(CMD, "< $bscmds_path{$scmd}")) {
    &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: file_hndlr: open($bscmds_path{$scmd}) failed: $!");
    return 0;
  }
  $cmd_h=""; 
  while (<CMD>) {
    $cmd_h .= $_;
  }
  close (CMD) || 
       &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: file_hndlr: close($bscmds_path{$scmd}) failed: $!");

  &util'parseopts('ri:f:c:',\%options,split(" ",$cmd_h));
  
  if ( !(defined($options{'i'})) ) {
    &util'msg($util'ERROR_MSG,"$0: Incorrect parameters i=$options{'i'}: not defined");
    return 0;
  }

  if (!open(NEWFILE,"<$options{'i'}") ) {
    &util'msg($util'ERROR_MSG,"$0: Unable to open input file: $options{'i'}: $!");
    return 0;
  }
  $imsg="";
  while (<NEWFILE>) {
    $imsg .= $_;
  }
  close(NEWFILE);

  if ( defined($options{'c'}) ) {
    ($basenm) = $options{'i'} =~ /.*\/(.*)/o;
    $options{'c'} = strftime($options{'c'},gmtime($stime)); 
    $options{'c'} =~ s/\$f/$basenm/g;
    ($dirnm) = $options{'c'} =~ /(.*)\/.*/o;
    if (!(-d $dirnm)) {
      if (-e $dirnm) {
        &util'msg($util'ERROR_MSG,"$0:FILE_hndlr: Cannot create $dirnm: file exist but not a directory");
        return 0;
      }
      @dirs = mkpath(dirname("$options{'c'}"));
      if (0 < @dirs) {
        &util'msg($util'INFO_MSG,"$0:FILE_hndlr: Create directories: @dirs");
      } 
      else {
        &util'msg($util'ERROR_MSG,"$0:FILE_hndlr: Cannot create directories: $dirnm");
        return 0;
      }
    }
    if ( exists( $options{'r'} )) {
      if (!open(DAILYFILE,">$options{'c'}") ) {
        &util'msg($util'ERROR_MSG,"$0: Unable to open output file(>): $options{'c'}: $!");
        return 0;
      }
    } 
    else {
      if (!open(DAILYFILE,">>$options{'c'}") ) {
        &util'msg($util'ERROR_MSG,"$0: Unable to open output file(>>): $options{'c'}: $!");
        return 0;
      }
    }
    print DAILYFILE $imsg;
    close DAILYFILE;

  # Completed this command successfully, however the normal
  # PID waitpid cleanup will not work because this work was done  
  # internally.  Need to delete the que command here..

    if ( !defined($options{'f'}) ) {  
      &util'msg($util'INFO_MSG,"$0: file_hndlr: ${scmd} completed succesfully: $options{'i'} written to $options{'c'}"); 
      unlink ("$bscmds_path{$scmd}") || 
        &util'msg($util'ERROR_MSG,"$0: file_hndlr: ulink($bscmds_path{$scmd}) failed: $!"); 
      return 1;
    }
  }
 

  if ((!defined($options{'f'}))) {
    &util'msg($util'ERROR_MSG,"$0: Incorrect parameters f=$options{'f'}, i=$options{'i'}");
    return 0;
  }
 
# this is the processing for the WMO message timestamp.

    ($_) = $imsg =~ /(^.*[^\n])/;

    if (! /$wmo_pattern_1/) {
      if ( $options{'f'} =~ /\$/) {
        &util'msg($util'ERROR_MSG,"$0: Unable to find wmo header in input file: $options{'i'}");
      } else {
        &util'msg($util'WARN_MSG,"$0: Unable to find wmo header in input file: $options{'i'}");
      }
    } 
    else {
      $3 =~ /(\d\d)(\d\d)(\d\d)/;
      $wmoday = $1; $wmohour = $2; $wmomin = $3;

      if ($options{'f'} =~ /\$/) { 

      @offset = (0,24*3600,-(24*3600),48*3600,-(48*3600));

      while (($wmoday != $tmday) && ($i < @offset)) {
        $ttime = $stime + $offset[$i++];
        ($tsec,$tmin,$thour,$tmday,$tmon,$tyear,$twday,$tyday,$tisdst) = gmtime($ttime);
      } 

      if ($wmoday == $tmday) {
        $thour = $wmohour;
        $tmin = $wmomin;
      }
      else {    # this is the case when I can't figure out the real month, year
                # I don't really know what to do so I am saving it as 1970. Jan
        $tmon = 0;
        $tyear = 1970;
        $tmday = $wmoday;
        $thour = $wmohour;
        $tmin = $wmomin;
        $tsec = 0;
        $twday = 1;
        $tyday = 1;
      }
     } 
   }

  $datestring = strftime($options{'f'},gmtime($stime));

# now replace the $ with % and strftime it again to handle the wmo date/time
  if ($datestring =~ s/\$/%/g) {
    $datestring = strftime($datestring,$tsec,$tmin,$thour,$tmday,$tmon,$tyear,$twday,$tyday,$tisdst);
    $datestring =~ s/%/\$/g;  # now replace any $ signs that were not strtime stuff. 
  }

  if (!(-e $datestring)) {
    @dirs = mkpath(dirname("$datestring"));
    if (0 < @dirs) {
      &util'msg($util'INFO_MSG,"$0:FILE_hndlr: Create directories: @dirs)");
    }
  }

  if ( exists( $options{'r'} )) {
    if (!open(DAILYFILE,">$datestring") ) {
      &util'msg($util'ERROR_MSG,"$0: Unable to open output file: $datestring, $!");
      return 0;
    }
  } else {
    if (!open(DAILYFILE,">>$datestring") ) {
      &util'msg($util'ERROR_MSG,"$0: Unable to open output file: $datestring, $!");
      return 0;
    }
  }

#  &util'msg($util'INFO_MSG,"$0: After open before process");
  
  print DAILYFILE $imsg;

  close (DAILYFILE) || &util'msg($util'ERROR_MSG,"$0: Unable to close output file: $datestring $!");

  # I have completed this command successfully, however the normal
  # PID waitpid cleanup will not work because I did this work 
  # internally.  I have to delete the que command myself..

  &util'msg($util'INFO_MSG,"$0: file_hndlr: ${scmd} completed succesfully: $options{'i'} written to ${datestring}"); 


  unlink ("$bscmds_path{$scmd}") || 
         &util'msg($util'ERROR_MSG,"$0: file_hndlr: ulink($bscmds_path{$scmd}) failed: $!"); 

  return 1;
}


sub ftpget_hndlr {
  local ($type,$subtype,$fakesubtype,@qarg,$localdir,$localfile,$perms,$owner,$group);
  local ($account,$password,$prefhostname,$junk,$datafilename,$mjob,$rfilesize,$rfiledate);
  local ($cpid, $busy_cmdfile,$cmd_h,$desthost,$datafile);

  foreach $cpid (keys %busy_cmds) {
    $busy_cmdfile = $busy_cmds{$cpid};
    next if ! ($busy_cmdfile =~ /$cmd_pattern/o);
    $cmd_b=$1, $site_b=$2, $msg_b=$3, $fsn_b=$4, $pid_b=$5, $ftime_b=$6;
    if ( $ftpget_check_busy_table == 2 ) {
       return 1 if ( ( $cmd_a  eq $cmd_b  ) &&
                     ( $site_a eq $site_b ) &&
                     ( $msg_a  eq $msg_b  )     ); 
    }
  }
  if (!open(CMD, "< $bscmds_path{$scmd}")) {
    &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: ftpget_hndlr: open($bscmds_path{$scmd}) failed: $!");
    return 0;
  }
  $cmd_h=""; 
  while (<CMD>) {
    chomp;
    $cmd_h .= $_;
  }
  close (CMD) || &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: ftpget_hndlr: close($bscmds_path{$scmd}) failed: $!");
  @qarg = split(/ /,$cmd_h);
  $desthost=$qarg[0], $type=$qarg[6], $datafile=$qarg[1], $mjob = $qarg[7] ,$rfilesize = $qarg[3], $rfiledate = $qarg[2];
  $subtype = $qarg[8];

  ($junk,$datafilename) = &util'split_path($datafile);

  if (!(($fakesubtype,$fakesubtype,$arg,$localdir,$localfile,$perms,$owner,$group,$clean)
          =&util'parse("msginfobycode", "$parse_table",  "$msg_a",  ".*",  "$datafile"))) {
    &util'msg($util'ERROR_MSG,"$0: parse(msginfobycode, ${parse_table}, ${msg_a}, .*, $datafile) failed!");
    return 0; 
  }

  if (!(($account,$password,$prefhostname)
          =&util'parse("siteinfobycode", "$parse_table",  "HOST",  "host",  "$site_a"))) {
    &util'msg($util'ERROR_MSG,"$0: parse(siteinfobycode, ${parse_table}, HOST,  host,  ${site_a} failed!");
    return 0; 
  }

# build local filename
  $destfile = $localdir . "/" . $localfile;

# clean up the path name
  $destfile =~ s/\/\//\//g;

# substitute preferred source hostname in local path
  if ( (defined $prefhostname) && ($destfile =~ /%H/) ) {
    $destfile =~ s/%H/$prefhostname/g;
  }

# check file size to avoid dowloading duplicates.  We may also want to check
# the date/time but that would be prone to errors because it is easy to change
# the date/time of a file....

  $lfilesize = (-s "$destfile");
  if ( ($dupcheck == 1) && $rfilesize && ( $lfilesize == $rfilesize ) ) {
    &util'msg($util'ERROR_MSG,"$0: Remote file size is equal to local file size, not downloading");
    return 0;
  }

  @qargs = ($FTPGET,$desthost,$datafile,$destfile,$account,$password,$owner,$group,$perms,$type,$subtype,$mjob,$arg,$clean); 

  $rval = launch($scmd, @qargs);
  if ($rval == 1) {
    if (defined $ftpget_cmds{"$site_a"} ) {
      $ftpget_cmds{"$site_a"}++ ;
    } else {
      $ftpget_cmds{"$site_a"} = 1;
    }
  }
  return $rval;
}

sub ldm_hndlr {
  1;
}

sub group_hndlr {
  my (@commandline,$groupline,$command,$mtype,$mscode,$msg,$mode,$name);
  local($single) = "single";
  
#  &util'msg($util'DEBUG_MSG,"starting GROUP handler");

  if (!open(CMD, "< ${dbnet_que}/${scmd}")) {
    &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: group_hndlr: open(${dbnet_que}/${scmd}) failed: $!");
    return 0;
  }

  $groupline= <CMD>;
  if (!($commandline = <CMD> )) {
    &util'msg($util'ERROR_MSG,"$0:Group $scmd empty");
    return 0;
  }

#  $groupline =~ /([\S]+)[ \t]+([\S]+)[ \t]+([\S]+)[ \t]+([\S]+)[ \t]+([\S]+)[ \t]+([\S]+)[ \t]+(.*)/;
  $groupline =~ /$groupline_pattern/;
  $mtype = $2; $mscode = $3; $mode = $4; $name=$5; $msg = $7; $fname = $8;
  $commandline =~ /$commandline_g_pattern/;
#  $commandline =~ /([\S]+)[ \t]+([\S]+)[ \t]+([\S]+)[ \t]+([\S]+)[ \t]+(.*)/;
  
  
  $command[0] = $5;
# check for same group already running ....
  if ($mode eq $single) {
    foreach $bcmd (keys %exec_cmds) {
      if ($name eq $exec_cmds{$bcmd}) {
        return 1;
      }

    }
    $exec_cmds{$scmd} = $name;
  }


  &util'msg($util'INFO_MSG,"Starting GROUP $name, $scmd ");
  $busy_cmds{$scmd} = $scmd;
  
  @a = &util'quecmd(*command,$dbnet_que,$fname,$fname,$parse_table,$msg);
#  &load_cmds();
  if (!defined @a || (@a < 1)) {
    &util'msg($util'ERROR_MSG,"$0:Group $scmd empty");
    delete $busy_cmds{$scmd};
    delete $exec_cmds{$scmd};
    return 0;
  }
 
  foreach (@a) {
    $group_cmds{$_} = "$scmd:0:$2:$4";
#    &util'msg($util'DEBUG_MSG,"Adding $_ to group commands");
  }
  1;
}


sub exec_hndlr {
local ($single);

  $single = "single";

#  &util'msg($util'DEBUG_MSG,"$0: starting exec handler"); 

  if (!open(CMD, "< $bscmds_path{$scmd}")) {
    &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: exec_hndlr: open($bscmds_path{$scmd}) failed: $!");
    return 0;
  }

  $cmd_h="";
  while (<CMD>) {
    chomp;
    $cmd_h .= $_;
  }
  close (CMD) || &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: exec_hndlr: close($bscmds_path{$scmd}) failed: $!");

  $cmd_h =~ /([\S]+)[ \t]+([\S]+)[ \t]*(.*)/;
  $exec_mode= $1, $hostcmd=$2, $qarg=$3;

# check for same command already running ....
  if ($exec_mode eq $single) {
    foreach $bcmd (keys %exec_cmds) {
      if ($hostcmd eq $exec_cmds{$bcmd}) {
        return 1;
      }

    }
  }
  
  @qargs=split(/[ \t]+/, $qarg);
  unshift(@qargs, $hostcmd);
  launch($scmd, @qargs);
}

sub pipe_hndlr {
  1;
}

sub dproc_hndlr {
  1;
}

sub launch {
  local($cmd, @cmds)=@_;
  local($cpid);

  if ($cpid = fork) {
    $busy_cmds{$cpid}=$cmd;
    $exec_cmds{$cpid}=$cmds[0];
#    &util'msg($util'DEBUG_MSG,"$0: added $cmds[0] to exec_cmds");

    return 1;
  } 
  elsif (defined $cpid) {
    exec @cmds;
    &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: launch: exec failed on $cmd: $!");
    exit $!;
  }
  else {
    &util'msg($util'ERROR_MSG,"$0: $cmdtype_in: launch: cannot start $cmd: $!");
    return 0;
  }
}


sub process_pending  {

  local (@cmds, $i,$files,$mtype, $hostid, $datatype, $seq);
  local ($rpid,$buildtime,@cmd_list,$j);

  if (!opendir(DIR, $pending_dir)) {
    &util'msg($util'ERROR_MSG,"$0: opendir($pending_dir) failed: $!");
    return;
  }

  @files=readdir(DIR);
  closedir(DIR);

  foreach $i (@files) {
    next if (($i =~ /^\./));
    # add a safety catch, this will prevent the pending processing from
    # taking over if there is a large backlog.  Given the limited size
    # of the process table theres no point to put more than 100 things
    # in the queue at a time.
    return if ($j++ > 100);
 
    ($mtype, $hostid, $datatype, $seq , $rpid, $buildtime) = split(/\./,$i);
    &util'dbn_rename("${pending_dir}/${i}","${timestamped_datadir}/${i}") || next; 

    if (!(@cmd_list=&util'parse("quecmd", "$parse_table", "$quecmd", "$mtype", "${hostid}${datatype}"))) {
      &util'msg($util'ERROR_MSG,"$0: parse(quecmd, $parse_table, $quecmd, $mtype, $hostid $datatype) failed!");
      &util'dbn_rename("${timestamped_datadir}/${i}", "${err_dir}/${i}");
      next;
    }

    if (!&util'quecmd(*cmd_list, $dbnet_que, "${timestamped_datadir}/${i}", $i, $parse_table, $datatype)) {
        &util'msg($util'ERROR_MSG,"$0: quecmd(cmd_list) failed");
        &util'dbn_rename("${timestamped_datadir}/${i}", "${err_dir}/${i}");
        next;
    }
  }  

}


sub process_table_is_full {
  my (@b_values,$real_process,$cpid,$busy_cmdfile);
#return 0;

#  @b_values = values(%busy_cmds);
#  return 0 if (@b_values < $qh_max_processes);

  $real_process = 0;
#  foreach (@b_values) {
  while (($cpid, $busy_cmdfile) = each %busy_cmds) {
    $real_process++ if ($busy_cmdfile !~ /^GROUP\./);
  }
  return 0 if ($real_process < $qh_max_processes);

  return 1;
}


sub process_foreign  {

  my ($i,$filename,$mtime, $host, $type, $subtype, $job);
  my ($input_line, @files);

  if (!opendir(DIR, $foreign_dir)) {
    &util'msg($util'ERROR_MSG,"$0: opendir($foreign_dir) failed: $!");
    return;
  }

  @files=readdir(DIR);
  closedir(DIR);

  foreach $i (@files) {
    next if (($i =~ /^\./));

    $mtime = (stat("${foreign_dir}/${i}"))[9];

    next if ($mtime+$foreign_wait_time > time);

      if (!open(IFILE,"$foreign_dir/$i")) {
      &util'msg($util'ERROR_MSG,"Unable to open foreign file: $foreign_dir/$i");
      next;
    }

    $input_line = <IFILE>;
    close (IFILE);

    if (!($input_line =~ /(\S+)[ \t]+(\S+)[ \t]+(\S+)[ \t]+(\S+)[ \t]+(\S+)[ \t]+(\S+)[ \t]+(\S+)[ \t]+(\S+)[ \t]+(\S+)/)) {
      &util'msg($util'ERROR_MSG,"Unable to match pattern in foreign file: $foreign_dir/$i"
);
      &util'dbn_rename("${foreign_dir}/${i}", "${err_dir}/${i}");
      next;
    }
    $host = $1; $filename = $2; $type = $7; $job = $8; $subtype = $9;

    if (&build_alert($host,$filename,$type,$subtype,$job)) {
      &util'dbn_rename("${foreign_dir}/${i}","${timestamped_datadir}/${i}") ||
        &util'msg($util'ERROR_MSG,"$0: dbn_rename($foreign_dir/$i,$timestamped_datadir/$i) failed!");
    }else {;
      &util'dbn_rename("${foreign_dir}/${i}","${err_dir}/${i}") ||
        &util'msg($util'ERROR_MSG,"$0: dbn_rename($foreign_dir/$i,$err_dir/$i) failed!");
   }
  }
}

sub build_alert {
  my ($host,$path,$type,$subtype,$jobname,$optional_file) = @_;
  my ($filedate, $size, $msgcode, $sitecode, $alert_msg_fn);
  my ($alert_msg);

  if ($optional_file && (! -r $optional_file)) {
    &util'msg($util'ERROR_MSG,"$0: optional_file $optional_file not readable: $!: disabling");
    $optional_file="";
  }


  if (!($msgcode=&util'parse("msgcode", "$parse_table",  "$type",  "$subtype",  "$path")))
  {
    &util'msg($util'ERROR_MSG,"$0: parse(msgcode, ${parse_table}, ${type},  ${subtype}, ${path}) failed!");
    return 0;
  }

  if (!($sitecode=&util'parse("sitecode", "$parse_table",  "HOST", "host",  "$host"))) { 
    &util'msg($util'ERROR_MSG,"$0: parse(sitecode, ${parse_table}, HOST, host, ${host}) failed!");
     return 0; 
  } 
 
  if (!($localsitecode=&util'parse("sitecode", "$parse_table",  "HOST", "host",  "$hostaddr"))) { 
    &util'msg($util'ERROR_MSG,"$0: parse(sitecode, ${parse_table}, HOST, host, ${hostaddr}) failed!");
    $localsitecode = "0000";
  }

  if ($sitecode eq $localsitecode) {
    if (!(($filedate, $size)=&util'build_filedate("$path"))) {
      &util'msg($util'ERROR_MSG,"$0: cannot build filedate");
      return 0;
    }
  } else {
    $filedate = 0;
    $size = 0;
  }

  $alert_msg_fn=&util'build_fn("$alert", "$sitecode", "$msgcode","0");
  $alert_msg="${timestamped_datadir}/${alert_msg_fn}";

  if (!open(ALERT, "> $alert_msg")) {
    &util'msg($util'ERROR_MSG,"$0: open $alert_msg failed: $!");
    return 0;
  }


  printf ALERT "%s %s %s %s %s %s %s %s %s\n", $host, $path, $filedate, $size, $noop, $noop, $type, $jobname ,$subtype;

  if ($optional_file) {
    if (!open(OPTIONAL_FILE, "$optional_file")) {
      &util'msg($util'ERROR_MSG,"$0: open optional_file $optional_file failed: $!: disabling");
      $optional_file="";
    }

   else {
      while (<OPTIONAL_FILE>) {
        print ALERT;
      }
      close(OPTIONAL_FILE) || &util'msg($util'ERROR_MSG,"$0: close optional_file $optional_file failed: $!");
    }
  }

  close ALERT || &util'msg($util'ERROR_MSG,"$0: close alert_msg $alert_msg failed: $!");
  &util'msg($util'INFO_MSG,"$0: created alert msg: $alert_msg");


  if (!(@cmd_list=&util'parse("quecmd", "$parse_table", "$quecmd", "$alert", "${sitecode}${msgcode}"))) {
    &util'msg($util'ERROR_MSG,"$0: parse(quecmd, $parse_table, $quecmd, $alert, $msgcode) failed!");
    &util'dbn_rename("$alert_msg", "${err_dir}/${alert_msg_fn}");
    return 0;
  }

  if (!&util'quecmd(*cmd_list, $dbnet_que, $alert_msg, $alert_msg_fn, $parse_table, $msgcode)) {
    &util'msg($util'ERROR_MSG,"$0: quecmd(cmd_list) failed");
    &util'dbn_rename("$alert_msg", "${err_dir}/${alert_msg_fn}");
    return 0;
  }
  return 1;
}


