#!/bin/perl

#-----------------------------------------------------------
#
# This program now requires a link to perl v5.002  in the
# DBNROOT/bin directory.  This was done to dependencies on 
# the location of the perl executable.
#-----------------------------------------------------------

$dbn_root=$ENV{'DBNROOT'};
require "${dbn_root}/table/dbn_config";

unshift(@INC, '.');
unshift(@INC, "$include_dir");

require 'dbn_util.pl';
use Socket;
require 'ftp.pl';



$version="v2.00 06/06/96";
chop( $host = `(hostname || uname -n || uuname -l) 2>/dev/null` );
$ftp_port=21;
$retry_call=1;
$attempts=2;
$connected="";
$curr_account="";
$can_restart=0;
$text_mode=0;
$timeout=120;
#$logfiledate=0;
#$logfilestokeep=4;
#$graceful_death=0;
#$inactive_time_allowed=720;
#$last_activity=time;
#$current_time=0;
#$xfer_count=0;


if (!&util'init()) {
  &util'msg($util'ERROR_MSG,"$0: init() failed!");
  exit 1;
}

&ftp'debug($debug);
&util'msg($util'INFO_MSG,"$0,FTP started, $version, $host, messages directed to log file");
&util'mapstreamtolog(*ftp'showfd);

#&ftp'debug(10);
#&ftp'set_signals( "main'msg" );
#&ftp'set_timeout( $timeout );

&FTPGET(@ARGV);

sub dir_exists
{
  local( $dir ) = @_;
  local( $val );

  $val = (-d $dir);
  return $val;
}



sub disconnect
{
  if( $connected ){
    &util'msg($util'INFO_MSG,"$0: Disconnect: $connected");
#   if( ! $ftp'fatalerror ){
       &ftp'quit();
#   }
  }
  $connected = '';
  $curr_account = '';
}


sub FTPGET {

  local( $desthost, $sourcefile, $destfile,$username, $password, $owner, $group, $perms ,$mtype, $msubtype, $mjob,$cleanpattern,$cleanvalue ) = @_;
  local( @parsed_path, $localdir, $localfile );
  my( $ret );

  &util'msg($util'INFO_MSG,"$0: called...$desthost, $sourcefile, $destfile,$username, <password>, $owner, $group, $perms");

  if ( $desthost && $sourcefile && $destfile  && $username && $password && $owner && $group && $perms && $mtype && $msubtype && $mjob ) {
    if ($connected ne $desthost || $username ne $curr_account) {
      &disconnect;
      &util'msg($util'DEBUG_MSG,"$0: ftp'open( $desthost, $ftp_port, $retry_call, $attempts )");
      if(&ftp'open( $desthost, $ftp_port, $retry_call, $attempts) <= 0) {
        &util'msg($util'ERROR_MSG,"$0: ftp'open failed....");
        &disconnect;
        exit 1;
      }
      &util'msg($util'DEBUG_MSG,"$0: ftp'login( $username, <password>)");
      if ( ! &ftp'login( $username, $password) ) {
        &util'msg($util'ERROR_MSG,"$0: cannot login $desthost $user <passwd>");
        &disconnect;
        exit 1;
      }
      $connected=$desthost;
      $curr_account=$username;
      $can_restart = (&ftp'restart(0) == 1);
#      &util'msg($util'DEBUG_MSG, "$0: can_restart=$can_restart" );
      if( ! &ftp'type( $text_mode ? 'A' : 'I' ) ){
        &util'msg($util'ERROR_MSG, "$0: cannot set type" );
      }
    }
    @parsed_path=split(/\//, $destfile);
    $localfile=splice(@parsed_path,$#parsed_path,1);
    $localdir = join ("/", @parsed_path);
#    print ("$0 PATHS: $localdir, $localfile\n");
#    $lfilesize=(-s "${localdir}/${localfile}");
#    if ( $lfilesize && $lfilesize == $filesize) {
#      &util'msg($util'ERROR_MSG,"$0: ${localdir}/${localfile} filesize ($filesize) same as in alert msg");
#      unlink("${q_dir}/.${message}") || die "$0: proc_qi: cannot unlink ${q_dir}/${message}\n";
#      exit 1;
#    }
    if (! &util'mkdirs($localdir)) {
#
#     unrecoverable error and do not retry get
#
      &util'msg($util'ERROR_MSG,"$0: cannot create dirs $localdir");
      exit 0;
    }
    &util'msg($util'DEBUG_MSG,"$0: ftp'get($sourcefile, ${localdir}/.${localfile}\n");
#
#   $ret == 1 -- good return
#   $ret == 0 -- recoverable error and retry get
#   $ret >  1 -- unrecoverable error and do not retry get
#
    $ret=ftp'get("$sourcefile", "${localdir}/.${localfile}", 0);
    if ($ret != 1) {
      &util'msg($util'ERROR_MSG,"$0: $ret=ftp'get failed $sourcefile -> ${localdir}/.${localfile}");
      &disconnect;
      exit 1 if $ret == 0; 
      exit 0; 
    }
    &disconnect; 
    chmod(oct($perms), "${localdir}/.${localfile}");
    chown($owner, $group, "${localdir}/.${localfile}");
    unlink("${localdir}/${localfile}");               # make sure the file doesn't already exist
    rename("${localdir}/.${localfile}", "${localdir}/${localfile}") 
     || &util'msg($util'ERROR_MSG,"$0: cannot rename ${localdir}/.${localfile} -> ${localdir}/${localfile}");
    system ("$bin_dir/dbn_alert", $mtype, $msubtype, $mjob, "${localdir}/${localfile}");

    if ($cleanval > 0) { 
      &util'cleanup(0,$cleanpattern,$cleanval);
    }
    exit 0;  
  }
  &util'msg($util'ERROR_MSG,"$0:  Invalid Parameter List");
  exit 1;
}    
