#!/bin/perl

#-----------------------------------------------------------
#
# This program now requires a link to perl v5.002  in the
# DBNROOT/bin directory.  This was done to dependencies on 
# the location of the perl executable.
#
# Author: Luis J. Cano
# Date:   12/26/95 
#-----------------------------------------------------------

$dbn_root=$ENV{'DBNROOT'};
require "${dbn_root}/table/dbn_config";

unshift(@INC, '.');
unshift(@INC, "$include_dir");

require 'dbn_util.pl';
require 'ftp.pl';



$version="v1.00 06/06/96";
chop( $host = `(hostname || uname -n || uuname -l) 2>/dev/null` );
$ftp_port=21;
$retry_call=1;
$attempts=2;
$connected="";
$curr_account="";
$can_restart=0;
$text_mode=0;
$timeout=120;
#$logfiledate=0;
#$logfilestokeep=4;
#$graceful_death=0;
#$inactive_time_allowed=720;
#$last_activity=time;
#$current_time=0;
#$xfer_count=0;


if (!&util'init()) {
  &util'msg($util'ERROR_MSG,"$0: init() failed!");
  exit 1;
}


&ftp'debug($debug);
&util'msg($util'INFO_MSG,"$0,FTPPUT started, $version, $host, messages directed to log file");
&util'mapstreamtolog(*ftp'showfd);

#&ftp'debug(10);
#&ftp'set_signals( "main'msg" );
#&ftp'set_timeout( $timeout );

&FTPPUT(@ARGV);

sub dir_exists
{
  local( $dir ) = @_;
  local( $val );

  $val = (-d $dir);
  return $val;
}



sub disconnect
{
  if( $connected ){
    &util'msg($util'INFO_MSG,"$0: Disconnect: $connected");
#   if( ! $ftp'fatalerror ){
       &ftp'quit();
#   }
  }
  $connected = '';
  $curr_account = '';
}


sub FTPPUT {

  local( $desthost, $sourcefile, $destfile,$username, $password, $owner, $group, $perms ,$mtype, $msubtype, $mjob, $cleanpattern,$cleanvalue ) = @_;
  local( @parsed_path, $localdir, $localfile );

  &util'msg($util'INFO_MSG,"$0: called...$desthost, $sourcefile, $destfile,$username, <password>, $owner, $group, $perms");

  if ( $desthost && $sourcefile && $destfile  && $username && $password && $owner && $group && $perms && $mtype && $msubtype && $mjob ) {
    if ($connected ne $desthost || $username ne $curr_account) {
      &disconnect;
      &util'msg($util'DEBUG_MSG,"$0: ftp'open( $desthost, $ftp_port, $retry_call, $attempts )");
      if(&ftp'open( $desthost, $ftp_port, $retry_call, $attempts) <= 0) {
        &util'msg($util'ERROR_MSG,"$0: ftp'open failed....");
        &disconnect;
        exit 1;
      }
      &util'msg($util'DEBUG_MSG,"$0: ftp'login( $username, <password>)");
      if ( ! &ftp'login( $username, $password) ) {
        &util'msg($util'ERROR_MSG,"$0: cannot login $desthost $user <passwd>");
        &disconnect;
        exit 1;
      }
      $connected=$desthost;
      $curr_account=$username;
      $can_restart = (&ftp'restart(0) == 1);
      &util'msg($util'DEBUG_MSG, "$0: can_restart=$can_restart" );
      if( ! &ftp'type( $text_mode ? 'A' : 'I' ) ){
        &util'msg($util'ERROR_MSG, "$0: cannot set type" );
      }
    }
    @parsed_path=split(/\//, $destfile);
    $localfile=splice(@parsed_path,$#parsed_path,1);
    $localdir = join ("/", @parsed_path);

    if (!ftp'cwd("$localdir")) {
      if (!ftp'cwd("/")) {
        &util'msg($util'ERROR_MSG,"$0: ftp'cwd failed for /");
        &disconnect; 
        exit 1;
      }
      &util'msg($util'WARN_MSG,"$0: Making directory $localdir on remote machine $desthost,!@parsed_path!");
      foreach (@parsed_path) {
        next if /^$/;
        if (!ftp'cwd("$_")) {
          &util'msg($util'WARN_MSG,"$0: Making directory $_ on remote machine $desthost");
          if (!ftp'mkdir("$_")) {
            &util'msg($util'ERROR_MSG,"$0: ftp'mkdir failed for $_");
            &disconnect; 
            exit 1;
          }
          if (!ftp'cwd("$_")) {
            &util'msg($util'ERROR_MSG,"$0: ftp'cwd failed for $_");
            &disconnect; 
            exit 1;
          }
        }
      }
    }
    
#    print ("$0 PATHS: $localdir, $localfile\n");
#    $lfilesize=(-s "${localdir}/${localfile}");
#    if ( $lfilesize && $lfilesize == $filesize) {
#      &util'msg($util'ERROR_MSG,"$0: ${localdir}/${localfile} filesize ($filesize) same as in alert msg");
#      unlink("${q_dir}/.${message}") || die "$0: proc_qi: cannot unlink ${q_dir}/${message}\n";
#      exit 1;
#    }
#    if (! &util'mkdirs($localdir)) {
#      &util'msg($util'ERROR_MSG,"$0: cannot create dirs $localdir");
#      exit 1;
#    }
    &util'msg($util'DEBUG_MSG,"$0: ftp'put($sourcefile, ${localdir}/.${localfile}\n");
    if (!ftp'put("$sourcefile", "${localdir}/.${localfile}")) {
      &util'msg($util'ERROR_MSG,"$0: ftp'put failed $sourcefile -> ${localdir}/.${localfile}");
      &disconnect; 
      exit 1;
    }
    ftp'chmod("${localdir}/.${localfile}",oct($perms)) ||
       &util'msg($util'ERROR_MSG,"$0: cannot ftp'chmod oct($perms) ${localdir}/.${localfile}");
#    chown($owner, $group, "${localdir}/.${localfile}");
#    unlink("${localdir}/${localfile}");               # make sure the file doesn't already exist
    ftp'rename("${localdir}/.${localfile}", "${localdir}/${localfile}") 
     || &util'msg($util'ERROR_MSG,"$0: cannot ftp'rename ${localdir}/.${localfile} -> ${localdir}/${localfile}");
    
    &disconnect; 
#    system ("$bin_dir/dbn_alert", $mtype, $msubtype, $mjob, "${localdir}/${localfile}");

#    if ($cleanval > 0) { 
#      &util'cleanup(0,$cleanpattern,$cleanval);
#    }
    exit 0;  
  }
  &util'msg($util'ERROR_MSG,"$0:  Invalid Parameter List");
  exit 1;
}    
