/*
 * dbn_bufr_dvr.c
 *
 * Distributed Brokered Networking (DBNet) bufr driver
 *
 * author: Luis J. Cano
 * date:   2/20/96
 *
 *
 */

#define _POSIX_SOURCE 1

#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <stdio.h>

/*
 * function prototype
 */



void dbn_bufr(char *subtype, int *subtypelen, unsigned char *msg, unsigned long *lenptr, int *iret );

int main( int argc, char **argv ) {

  int iret;
  FILE *fp;
  unsigned char *msg;
  struct stat sbuf;
  unsigned long len; int subtypelen;
  
  if (argc!=3) {
    (void)fprintf(stderr, "\nusage: %s subtype path\n", argv[0]);
    exit(EXIT_FAILURE);
  }

  if (stat(argv[2], &sbuf)<0) {
    perror("stat");
    (void)fprintf(stderr, "%s_drv: stat(%s) failed\n", argv[0], argv[2]);
    exit(EXIT_FAILURE);
  }
    
  if ((fp=fopen(argv[2], "r"))==NULL) {
    (void)fprintf(stderr, "%s_drv: fopen(%s) failed\n", argv[0], argv[2]);
    exit(EXIT_FAILURE);
  }

  if ((msg=malloc(sbuf.st_size))==NULL) {
    (void)fprintf(stderr, "%s_drv: malloc(%u) failed\n", argv[0], sbuf.st_size);
    exit(EXIT_FAILURE);
  }

  if (fread(msg, 1, sbuf.st_size, fp)!=sbuf.st_size) {
    (void)fprintf(stderr, "%s_drv: fread() %s failed\n", argv[0], argv[2]);
    exit(EXIT_FAILURE);
  }

  fclose(fp);

  (void)fprintf(stderr, "\n%s_drv: calling dbn_bufr...\n", argv[0]);
  len=sbuf.st_size/4;
  subtypelen=strlen(argv[1]);
  dbn_bufr(argv[1], &subtypelen, msg, &len, &iret);
  (void)fprintf(stderr, "\n%s_drv: %i=dbn_bufr(%s, %p, %u)\n", argv[0], iret, argv[1], msg, len);
  free(msg);
  exit(EXIT_SUCCESS);
}
