#!/usr/bin/perl -w

#-----------------------------------------------------------

if (@ARGV != 2) {
  printf STDERR "\nusage: $0 dirname pattern\n";
  exit 1;
}

$dir=shift;
$pattern=shift;

opendir(DIR, $dir) || die "\n$0: cannot open $dir: $!";

print "$0: reading files from $dir...\n";

@files=readdir(DIR);

print "$0: finish reading $dir\n";

foreach $file (@files) {
  next if "${dir}/${file}" eq '.';
  next if "${dir}/${file}" eq '..';
  if (!open(FILE, "${dir}/${file}")) {
    warn "$0: cannot open ${dir}/${file}: $!"; 
    next;
  }
  while (<FILE>) {
    print "${dir}/${file}: $_" if /$pattern/;
  }
  close(FILE);
}

print "$0: all done\n";
exit 0; 
