#!/ncep/prod/dbnhprod/bin/perl

#-----------------------------------------------------------
# Distributed Brokered Networking (DBNet) enuff perl script.
# exits:  0 = set = good rtn
#             test = good rtn, not enuff
#         1 = set = bad rtn
#             test = bad rtn
#         2 = test = good rtn, enuff
#
# author: Luis Cano
# date:   07/20/96
#-----------------------------------------------------------

$dbn_root = $ENV{'DBNROOT'};

if (!defined($dbn_root) || !$dbn_root) {
  print STDERR "\n$0: environment variable DBNROOT not set!\n";
  exit 1;
}

$dbn_config="${dbn_root}/table/dbn_config";
require "$dbn_config";

unshift(@INC, '.');
unshift(@INC, "$include_dir");

require 'dbn_util.pl';

if (!&util'init()) {
  &util'msg($util'ERROR_MSG,"$0: init() failed!");
  exit 1;
}

my($i, $j, $enuff_log_fn, @enuff_log, @fcst_lst, $timeout);
my($what_to_do, $which, $date, $cycle, $fcst_hr, $fcst_hrs);

$what_to_do=shift;
$which=shift;
$date=shift;
$cycle=shift;
$fcst_hr=shift;

if ( !what_to_do || !$which || !$date || !$cycle ) {
  usage();
  exit 1;
}

$parse_table="$tbl_dir/enuff.tbl";
$enuff_log_fn="$tmp_dir/enuff.$which.$date.$cycle";

#
# Log entry
#
&util'msg($util'INFO_MSG,"$0: entry what_to_do=${what_to_do} which=${which} date=${date} cycle=${cycle} fcst_hr=${fcst_hr}");

#
# set fcst hour in log
#
if ( $what_to_do eq "set" ) {
  if ( !($fcst_hr) ) {
    usage();
    exit 1;
  }
  if (!(open(ENUFF, ">> $enuff_log_fn"))) {
    &util'msg($util'ERROR_MSG,"$0: >> open $enuff_log_fn failed: $!");
    exit 1;
  }
  print ENUFF "$fcst_hr\n";
  close(ENUFF) || &util'msg($util'ERROR_MSG,"$0: close $enuff_log_fn failed: $!");
  exit 0;
}
#
# test to see if all fcst hours are in
#
elsif ( $what_to_do eq "test" ) {
  if (!open(ENUFF, "$enuff_log_fn")) {
    &util'msg($util'ERROR_MSG,"$0: open $enuff_log_fn failed: $!");
    exit 1;
  }
  while (<ENUFF>) {
    next if /(^[ \t]*\#)|(^[ \t]*$)/;
    chop if /.*\n/;
    push(@enuff_log, $_);
  }
  close(ENUFF) || &util'msg($util'ERROR_MSG,"$0: close $enuff_log_fn failed: $!");
  if (!(($fcst_hrs, $timeout)=&util'parse("account", "$parse_table",  "ENUFF",  "$which",  "$cycle"))) {
    &util'msg($util'ERROR_MSG,"$0: parse(account, ${parse_table}, ENUFF,  ${which},  ${cycle}) failed!");
    exit 1; 
  }
  @fcst_lst=split(/\|/, $fcst_hrs);
  exit 0 if @fcst_lst > @enuff_log;
  for ($i=@fcst_lst; $i > 0;  $i--) {
    for ($j=@enuff_log; $j > 0; $j--) {
      if ($fcst_lst[$i-1] eq $enuff_log[$j-1]) {
        splice(@fcst_lst, $i-1, 1);
        splice(@enuff_log, $j-1, 1);
        last;
      }
      elsif ( $j == 1 ) {
        exit 0;
      }
    }
  }
  exit ((!@fcst_lst) ? 2 : 0);
}
else {
  &usage;
  exit 1;
}

sub usage {
  &util'msg($util'ERROR_MSG,"usage: $0 set  which date cycle fcst_hr");
  &util'msg($util'ERROR_MSG,"usage: $0 test which date cycle");
}
