#!/bin/bash

#-----------------------------------------------------------
# dbn_health.sh
#-----------------------------------------------------------

# this script will report the health of the DBNet installation.
# the script does not try to determine if any thing is wrong it just
# reports the facts.

# first check the directories for the number of files.
echo "The dbnet_que has `ls -1 $DBNROOT/dbnet_que | wc -l` files"
echo "The pending queue has `ls -1 $DBNROOT/pending | wc -l` files"
echo "The err directory has `ls -1 $DBNROOT/err | wc -l` files"
echo "The tmp directory has `ls -1 $DBNROOT/tmp | wc -l` files"

# now print out the disk usage for the entire system
echo
echo "The disk usage is:"
df

# now check for key processes.
qh_process=dbn_qh.pl
ex_process=dbn_external.pl
IF_process=IFSP
mon_process=dbn_monsrv.pl
x224_process=dbn_x224.pl

echo
echo "Now checking for key processes:"
for i in dbn_qh.pl dbn_external.pl IFSP dbn_monsrv.pl dbn_x224.pl; do
  if [ `ps axww | grep -c $i` -eq 0 ]; then
    echo " $i is not running"
  else
    echo " $i is running"
  fi
done

echo
echo

exit 0


