#!/bin/sh
#
# arg1 = which dcom
# arg2 = QPF or QPE
# arg3 = Product Message filename
#


PDS_info=`$DBNROOT/user/printPDS $3`
if [ $? -ne 0 ]
then
  echo "$0: $DBNROOT/user/printPDS $3 failed"
  exit 1
fi

Century_init_ref=`echo $PDS_info | cut -d' ' -f11`
Year_of_century=`echo $PDS_info | cut -d' ' -f2`  
Product_year=`expr \( $Century_init_ref - 1 \) \* 100 + $Year_of_century`

Month_day=`echo $PDS_info | cut -d' ' -f3``echo $PDS_info | cut -d' ' -f4`
ID_of_center=`echo $PDS_info | cut -d' ' -f1`
ID_of_subcenter=`echo $PDS_info | cut -d' ' -f12`

Dest_dir="$1/$Product_year$Month_day/wgrbbul"
Dest_filename="$2.$ID_of_center.$ID_of_subcenter"

if [ ! -d $Dest_dir ] 
then
  mkdir -p $Dest_dir 2> /dev/null
fi

cat $3 >> $Dest_dir/$Dest_filename
