#!/usrx/local/perldbn/perl
##
#
#
# dbn_siphon.pl (* for SP -- the milkshake)
#
# Distributed Brokered Networking (DBNet) siphon alert perl script
#
# author: Luis Cano
# date:   12/27/99
#
#
#

use English;
$dbn_root="/gpfs/nco/dbnet";
$dbn_config="${dbn_root}/table/dbn_config";
require $dbn_config;
unshift(@INC, '.');
unshift(@INC, "$include_dir");
require 'dbn_util.pl';

# better untainting.
$ENV{PATH} = $dbn_env_path;

# determine hostname, suid style
local $sitecode="";
die unless defined($pid = open(KID, "-|"));
if ($pid) {   # parent
  while (<KID>) {
    $sitecode = $sitecode . $_;
  }
  close KID;
}
else {
  $EUID = $UID;
  $EGID = $GID;
  $ENV{PATH} = "/usr/bin";
  $ENV{ENV} = env;
  exec "hostname", "-s";
  die "can't exec hostname -s";
} 
chomp $sitecode;
#local $msgcode="$^T" . "_" . int(rand(99999)) . "_" . "$<" . "_" . "$>" . "_" . getppid;
local $msgcode=int(rand(99999)) . "_" . "$<" . "_" . "$>";
# $^T = script start time
# random number
# $<  = real user id
# $>  = effective user id
# getppid = parent pid
#
local $my_hostname="ncosp.ncep.noaa.gov";
local($type, $subtype, $path, $f, $dir);
local($size, $filedate, $alert_msg, $alert_msg_fn, $xlated); 

if (!&util'init()) {
  &util'msg($util'ERROR_MSG,"$0 (*): init() failed!");
  exit 1;
}

if (!$sitecode) {
  &util'msg($util'ERROR_MSG,"$0 (*): sitecode not set: hostname -s failed");
  exit 1;
}

if (@ARGV != 4) {
  &util'msg($util'ERROR_MSG,"usage: $0 type subtype jobname fullpath");
  exit 1;
}

$type=shift;
$subtype=shift;
$jobname=shift;
$path=shift;

# beef up the message code
$xlated = $type; $xlated =~ s/\W/_/g; $msgcode = $msgcode . "_" . "$xlated";
$xlated = $subtype; $xlated =~ s/\W/_/g; $msgcode = $msgcode . "_" . "$xlated";
$xlated = $jobname; $xlated =~ s/\W/_/g; $msgcode = $msgcode . "_" . "$xlated";
$msgcode = $msgcode . "_" . getppid;

&util'msg($util'INFO_MSG,"$0 (*): entry type=$type subtype=$subtype job=$jobname path=$path");

($dir, $f) = $path =~ /(.*)\/(\S+)$/;

if (!(($filedate, $size)=&util'build_filedate("$path"))) {
  &util'msg($util'ERROR_MSG,"$0 (*): cannot build filedate");
  exit 1;
}
  
$alert_msg_fn=&util'build_fn("$alert", "$sitecode", "$msgcode","0");
$alert_msg="${foreign_dir}/${alert_msg_fn}";

# realy bad way to untaint our variable
$alert_msg =~ /(.*)/;
$alert_msg = $1;

if (!open(ALERT, "> $alert_msg")) {
  &util'msg($util'ERROR_MSG,"$0 (*): open $alert_msg failed: $!");
  exit 1;
}


printf ALERT "%s %s %s %s %s %s %s %s %s\n", $my_hostname, $path, $filedate, $size, $noop, $noop, $type, $jobname ,$subtype;

close ALERT || &util'msg($util'ERROR_MSG,"$0 (*): close alert_msg $alert_msg failed: $!");
&util'msg($util'INFO_MSG,"$0 (*): created alert msg: $alert_msg");


exit 0;
