#define _POSIX_SOURCE 1

#include <stdio.h>
#include <time.h>
#include <unistd.h>
#include <fcntl.h>

#include "status.h"

extern char *envvar;


int UpdateStatusFile(int seqnumber, char *job, char *key, char *model, char *file) 
{
  FILE *fh;
  int count = 0;
  int number = 0;
  int tmp = 0;
  int lines=1;
  const char filename[256];

  struct tm *ztime;
  time_t ltime;

/*  char seqstring[100];
  char datestring[100];
  char keystring[100];
  char modelstring[100];
  char filestring[100];
 */ 
  strncpy(filename,envvar,247);
  if (filename[strlen(filename)-1] != '/') 
    strcat(filename,"/");
  strcat(filename,"statfile");
  
  ltime = time(0);
  ztime = gmtime(&ltime);

  while ((fh = fopen(filename,"r+")) == NULL ) {
    fprintf(stderr,"Cannot open status file: %s, in UpdateStatusFile, retrying\n",filename);
    sleep(2);
    count++;
    if (count > 5) {
      fprintf(stderr,"Open Status file failed\n");
      return -1;
    }
  }

  if (fseek(fh,LINELENGTH*(seqnumber-1),SEEK_SET) != 0) {
    fprintf(stderr,"Unable to seek to the correct line in statfile\n");
    return -1;
  } else {
  fprintf(fh,"%04d.%4s %02d.%03d.%02d:%02d:%02d %*.*s %*.*s %*.*s\n",
           seqnumber,key,ztime->tm_year % 100,ztime->tm_yday+1,ztime->tm_hour,
           ztime->tm_min,ztime->tm_sec,JOBLEN,JOBLEN,job,
           MODELLEN,MODELLEN,model,MAXFILENAMELEN,MAXFILENAMELEN,file);

  }


  fclose(fh);
  return GOODRETURN;

}

