#!/bin/sh
# This script will use dd, tr and the status program to convert an ascci
# tran file to ebcdic and notify OSO the file is available.  
# The enviornment variable TMPDIR must be set for this script to
# operate correctly.  A temp file is created using the PID in the
# TMPDIR.  
#
# The temp file will not be deleted if the tr command fails.
# If any step fails the statfile will not be updated.
#

#STATFILE=/pcom/status
#DBNROOT=/dbn4prd_dq/dbnprd

#export STATFILE DBNROOT 

DATADIR=$STATFILE/data
TMPDIR=$DBNROOT/tmp
STATUS=$DBNROOT/user/status

KEY=`echo $1 | tr "[:lower:]" "[:upper:]"`
FILENAME=$4
case "$KEY" in
TRAN)
# do tran type conversion here.
  FILENAME=$DATADIR/`basename $4`
  TMPFILENAME=$TMPDIR/`basename $4`$$
#  dd conv=ebcdic cbs=1280 if=$4 of=$TMPFILENAME 
  MPC_PRODUCT=0
  if [ `od -A n -j 40 -N 7  -t c $4 | tr -d "\ " | egrep -c "FZ(NT|PN)" ` -ne 0 ]
  then
   MPC_PRODUCT=1
  fi
  tr -d "\n" < $4 | dd conv=ebcdic of=$TMPFILENAME 
  case $? in
    0) ;;
    *) echo "Unable to call dd to convert $4 to $TMPFILENAME";exit -1 ;;
  esac
  tr "\232" "\137" <$TMPFILENAME > $FILENAME
  if [ $MPC_PRODUCT -eq 1 ]
  then 
      tr "\133" "\147" < "$FILENAME" > $TMPFILENAME
      cp $TMPFILENAME $FILENAME
  fi
  case $? in
    0) ;;
    *) echo "Unable to call tr to convert $TMPFILENAME to $FILENAME";exit -1 ;;
  esac
  rm $TMPFILENAME
  case $? in
    0) ;;
    *) echo "Unable to call rm to delete $TMPFILENAME";exit -1 ;;
  esac
  ;;
esac

$STATUS $KEY $2 $3 $FILENAME

