#define _POSIX_SOURCE 1


#include <stdio.h>
#include "status.h"


extern int errno;
extern char *envvar;

int GetSequenceNumber(void)
{
  FILE *fh;
  int count = 0;
  int number = 0;
  int tmp = 0;
  char perm_file[256];

  strncpy(perm_file,envvar,247);
  if (perm_file[strlen(perm_file)-1] != '/') 
    strcat(perm_file,"/");
  strcat(perm_file,"update");

  while ((fh = fopen(perm_file,"r")) == NULL ) {
    fprintf(stderr,"Cannot open update file: %s, in GetSequenceNumber, retrying\n",perm_file);
    sleep(2);
    count++;
    if (count > 5) {
      fprintf(stderr,"Open update file failed\n");
      return -1;
    }
  }

  tmp = fscanf(fh,"%d",&number);

  fclose(fh);
  
  if (tmp != 1) {
    fprintf(stderr,"Error scaning number from %s file\n",perm_file);
    return -1;
  }

  return number;

}


int UpdateSequenceNumber(int newnumber) 
{
  FILE *fh;
  int count = 0;
  int number = 0;
  int tmp = 0;
  char tmp_file[256];
  char perm_file[256];
  

  strncpy(tmp_file,envvar,247);
  if (tmp_file[strlen(tmp_file)-1] != '/') 
    strcat(tmp_file,"/");
  strcat(tmp_file,".update");
  strncpy(perm_file,envvar,247);
  if (perm_file[strlen(perm_file)-1] != '/') 
    strcat(perm_file,"/");
  strcat(perm_file,"update");

  while ((fh = fopen(tmp_file,"w")) == NULL ) {
    fprintf(stderr,"Cannot open temp update file: %s, in UpdateSequenceNumber, retrying\n",tmp_file);
    sleep(2);
    count++;
    if (count > 5) {
      fprintf(stderr,"Open temp update file failed\n");
      return -1;
    }
  }

  fprintf(fh,"%04d\n",newnumber);

  fclose(fh);

  if (rename(tmp_file,perm_file) != 0) {
    fprintf(stderr,"Unable to rename %s to %si: err=%d\n",tmp_file,perm_file,errno);
    return -2;
  }

  return number;
}

 
