#include <stdio.h>
#include <time.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>

#include "status.h"

int BeginLock(FILE *fh,struct flock *flockptr);
int EndLock(FILE *fh,struct flock *flockptr);
char *envvar = NULL;

int main() 
{
  FILE *fh;
  int count = 0;
  int number = 0;
  int tmp = 0;
  int lines=1;
  struct flock flockptr;


  envvar = getenv("STATFILE") ; 


   if (envvar == NULL) {
    fprintf(stderr,"ENV var not set\n");
    return -6;
  }
  
  BeginLock(fh,&flockptr);

  printf("Sleeping until a key is pressed ( the file is open )\n");
  getchar();

  EndLock(fh,&flockptr);

  fclose(fh);

}


int BeginLock(FILE *fh,struct flock *flockptr)
{
  int count = 0; 
  char filename[256];

  strncpy(filename,envvar,255);
  if (filename[strlen(filename)-1] != '/') 
    strcat(filename,"/");
  strcat(filename,".statlock");

  while ((fh = fopen(filename,"w")) == NULL ) {
    fprintf(stderr,"Cannot open sync file: %s, in BeginLock, retrying\n",filename);
    sleep(2);
    count++;
    if (count > 5) {
      fprintf(stderr,"Open sync file failed\n");
      return -1;
    }
  }
  

  flockptr->l_type = F_WRLCK;
  flockptr->l_start = 0;
  flockptr->l_whence = SEEK_SET;
  flockptr->l_len = 0;
  count = 0;
  while (fcntl(fileno(fh),F_SETLK,flockptr) == -1) {
    fprintf(stderr,"Unable to lock sync file, retrying\n");
    sleep(2);
    count++;
    if (count > 5) {
      fprintf(stderr,"Lock sync file failed\n");
      fclose(fh);
      return -1;
    }
  }
  return 0;
}


int EndLock(FILE *fh,struct flock *flockptr)
{
  int count = 0; 
/*
  flockptr->l_type = F_WRLCK;
  flockptr->l_start = 0;
  flockptr->l_whence = SEEK_SET;
  flockptr->l_len = 0;

  if (fcntl(fileno(fh),F_SETLK,flockptr) == -1) {
    fprintf(stderr,"Unable to unlock sync file, retrying\n");
    sleep(2);
    count++;
    if (count > 5) {
      fprintf(stderr,"UnLock sync file failed\n");
      fclose(fh);
      return -1;
    }
  }
*/
  fclose(fh);
  return 0;
}
