#!/bin/bash 

#-----------------------------------------------------------
# this script will check the files within the $1 subdirectory
# against the volc_regex file of regular expressions, and, for any
# file which contains a match, will alert it to DBNet
#
#
# Programmer	Date		Description
# ------------  --------        -----------------------------------
# R.Romero	01/21/99	Changed /usr/home...volc_regex to
# 				/usr/DBNet/user/volc_regex.
#				Changed path to grep utility.
# J.Ator/L.Cano	03/09/00	Rewritten for separate volcano_que 
#-----------------------------------------------------------


# check that we have exactly one argument
case $# in
1);;
*) exit -1;;
esac


. $HOME/.profile

cd $1

while [ 0 ]
do

    for file in `ls -1`
    do

        count=`grep -c -f /usr/DBNet/user/volc_regex $file`

        if [ $count -gt 0 ]
        then
            newname=`echo $file | sed "s/\.WB[0-9][0-9]\./\.VOLCANO\./"`
            mv $file $DBNROOT/pending/$newname
	else
            rm $file 
        fi

    done

    sleep 5

done
