/*
 * @(#)IFP_rpc.x
 *
 * Author: Luis J. Cano
 * Date:   01/18/95
 *
 * Description: RPC InterFace Front End support 
 *
 */

const MAX_VERBAGE_LEN = 2048;
const MAX_PATH_LEN = 1024;
const MAX_AUTHENTICATE_LEN = 128;
const MAX_EXEC_ARG_LEN = 1024;
const MAX_FILE_FLAGS = 8;
const MAX_FILE_LEN = 128;


/*
 * typedefs
 */

typedef opaque msgT<>;



/* 
 * InterFace server results
 */

struct svr_result {
	int code;
	string verbage<MAX_VERBAGE_LEN>;
};


/*
 * InterFace formal paramter list
 *
 */



struct svr_fparams {

	/* run mode */

	bool		verbose;
	bool		debug;

	/* only do the work if the following file exists on the server */
	string do_this_if<MAX_FILE_LEN>;

        /* pending - used with DBNet processing */
        string save_pending_file<MAX_PATH_LEN>;

	/* save msg file on server params */
	string save_msg_path<MAX_PATH_LEN>;
	string save_msg_file_open_flags<MAX_FILE_FLAGS>;
	int    save_msg_file_uid;
	int    save_msg_file_gid;
        int    save_msg_file_mode;


	/* execution order 1 */

	int exec_if1;
	string exec_path1<MAX_PATH_LEN>;
	string exec_arg1a<MAX_EXEC_ARG_LEN>;
	string exec_arg1b<MAX_EXEC_ARG_LEN>;
	string exec_arg1c<MAX_EXEC_ARG_LEN>;
	string exec_arg1d<MAX_EXEC_ARG_LEN>;


	/* execution order 2 */

	int exec_if2;
	string exec_path2<MAX_PATH_LEN>;
	string exec_arg2a<MAX_EXEC_ARG_LEN>;
	string exec_arg2b<MAX_EXEC_ARG_LEN>;
	string exec_arg2c<MAX_EXEC_ARG_LEN>;
	string exec_arg2d<MAX_EXEC_ARG_LEN>;


	/* authenicate InterFace */

	string authenicateInterFace<MAX_AUTHENTICATE_LEN>;


	/* client info */

	int	cl_ruid;
	int	cl_euid;
	int	cl_rgid;
	int	cl_egid;
	int	cl_pid;
	int	cl_ppid;
	int	cl_pgrp;

	/* incoming msg info */

	msgT		msg;


};



program IF_PROG {
        version IF_VER {
                svr_result INTERFACE_SVRP(svr_fparams)=1;
        } = 1;
} = 0x20000065;


