#!/usr/bin/perl -w
##perl script to install DBNet interactively by the user.
##date :02/16/00 revised 07/25/00
##author: C.Thiaw
#
# caution: before using this script for installing Dbnet:
# create an account for DBNet following these rules:
# if your machine name is "mach", the dbnet account can be named "dbnmach";
# create the home directory for this account
#
##########################################################
# set the DBNROOT environment
#########################################################

use File::Basename;

require 'install_dbnet.in';

unshift(@INC, '.');
unshift(@INC, "$dbnet_tar");
unshift(@INC, "$ifp_tar");
unshift(@INC, "$dbnet_root_dir");
unshift(@INC, "$dir");
unshift(@INC, "$dbndir");
unshift(@INC, "$sec_tar");
unshift(@INC, "$ifpdir");

# set up temporary  DBNROOT env. variable
$ENV{"DBNROOT"} = "$dbnet_root_dir";

#@res = &install'init();

#chop ($res[0]); $dbnet_tar = $res[0];
#chop ($res[1]); $ifp_tar = $res[1];
#chop ($res[2]); $dbnet_root_dir = $res[2];
#chop ($res[3]); $dir = $res[3];
#chop ($res [4]); $dbndir = $res [4];
#chop ($res[5]); $sec_tar = $res[5];
#chop ($res[6]); $ifpdir = $res[6];

my ($tmp, $answer, $in, @myperl, $myperl, $os, $shell, $sh, $newstart, $prof, $newprof);
my ($src, $bin, $conf, $log, $table, $cron, $user, $newbin, $newprog, $defaut_dir);
$count = 0;
@myperl = "";
$src = "src";
$bin = "bin";
$conf = "configure";
$log = "log";
$table = "table";
$cron = "cron";
$user = "user";
$newbin = "bin.ifp";
$newprog = "temposcript";
$prof = ".profile";
$newprof = ".newprofile";
$start = ".cshrc";
$newstart = ".newcshrc";
$packages = "packages";

print " \n\n...installing $dbnet_tar...\n\n\n";

mkdir ("$dbndir", 0755) || die "cannot mkdir $dbndir:$!";

print " DBNet default home directory is $dir. Do you want to install dbnet in $dir?";
print " \nHit 'carriage return' for yes, 'n' for no.\n";
print "\n";
  chomp ($ans = <STDIN>);
      if ($ans =~ /^n/i) {
           print "Please, enter the absolute path of the directory where you'd like to install dbnet:\n";
          chomp ($dir = <STDIN>);
          $ENV{"DBNROOT"} = "$dir/$dbndir";
          $dbnet_root_dir = $ENV{"DBNROOT"};
         run_script ();
                         }
      else {
          run_script ();
            }

sub run_script {

###perl
    print "\n...checking on perl ...\n\n";
    open (PP, "whereis 'perl'|");
    while ($in = <PP> ) {
      @p = split (/\s+/, $in);
      foreach $p (@p) {
         if (($p !~ /perl:$/) && ($p !~ /man/)) {
             print $p, "\n";
             push (@myperl,$p);
                                              }
                       }
                        }
    $s = @myperl;
  #  print $s, "\n";
    if ($s == 1) {
    open (VER, "perl -v|");
    $i = 0;
    while ($ver = <VER> ) {
      @p = split (/\s+/, $ver);
      $b = @p;
      for ($j =0; $j <$b; $j++) {
         if ($p[$j] =~  /version/)  {
            $i++;
    #        $version = $p[$j+1];
                                    }
         if ($p[$j] =~  /v*\d*/) {
            $i++;
           # $version = $p[$j];
                                }
                                 }
                        }
     

   if ($i == 0) {
      print "Perl does not exist or is not in the cwd's path.\n";
      print "Do you know any perl DBNet could use?\n";
      chomp ($ans = <STDIN>);
      if ($ans =~ /^y/i) {
             print "Please, enter the path name for perl:\n";
             chomp ($perl = <STDIN>);
                         }
       if ($ans !~ /^y/i) {
            print "Sorry, DBNet needs to locate perl. Extend your path or look for perl before running the programm again.\n";
             exit;
                           }
                }
    if ($i != 0) {
    #   print "Perl version is $version;\n";
       open (PL, "which perl|");
        while ($p = <PL>) {
        if ($p =~ /\/perl/) {
          print $p, "\n";
          $perl = $p;
                              }
        if ($p !~ /\/perl/)  {
          print "can't find perl, \n";
          print "Do you know any perl DBNet you could use?\n";
         if ($ans =~ /^y/i) {
             print "Please, enter the perl version you'd like to use:\n";
             chomp ($perl = <STDIN>);
                             }
         if ($ans !~ /^y/i) {
            print "Sorry, DBNet needs to locate perl. Extend your path or look for perl before running the programm again.\n";
             exit;
                            }
                             }
                          }
              }
                 }

## check for the major perl and set it to $perl- to do

     if ($s != 1) {
         print "Please, enter the perl version you'd like to use:\n";
         chomp ($perl = <STDIN>);
         foreach $myperl (@myperl) {
       if ($perl eq $myperl) {
          $count++;
                             }
                                   }
       if ($count == 0) {
        print "Sorry, $perl doesn't exist.\n";
        exit;
                        }
      else {
        print "$perl found. \n";
           }

      $count = 0;
                 }


###times_modules

    print "\n...checking on Times_modules ...\n\n";

     system ("perl -e 'use Time::CTime'") && warn "\nYou must install the time modules in order to use DBNet.\nThe time modules are available at www.cpan.org\n";



###dbnet root directory
   

   print "********************************************************************\n";
   print "USE $dir/$dbndir WHEN PROMPTED TO ENTER THE INSTALL PREFIX.\n";
   print "********************************************************************\n\n";
   
   system ("tar -xvf '$dir/$dbnet_tar'");
   system ("mv -f $ifp_tar $dbndir");
   system ("mv -f $sec_tar $dbndir");


   chdir ("$dbnet_root_dir");
   system ("tar -xvf '$dbnet_root_dir/$ifp_tar'");

   system ("pwd");


### run "configure" script to build IFCP/IFSP
    chdir ("$dbnet_root_dir/$ifpdir/$src");

    system("pwd");
         print "\nRunning IFP configuration script...\n";
         system ("$dbnet_root_dir/$ifpdir/$src/$conf");

## make clean
    print "\nRunning IFP make clean...\n";
    chdir ("$dbnet_root_dir/$ifpdir/$src");
         system ("make clean");

## make
    print "\nRunning IFP make...\n";
    chdir ("$dbnet_root_dir/$ifpdir/$src");
         system ("make");

##make install
    print "\nRunning IFP make install...\n"; 
    chdir ("$dbnet_root_dir/$ifpdir/$src");
         system ("make install");

### mv bin -> bin.ifp and rm log and table directories
 
 chdir ("$dbnet_root_dir");

 rename ("$bin", "$newbin") || die "cannot rename $bin to $newbin:$!";
 system ("rm -rf $dbnet_root_dir/$log");
 system ("rm -rf $dbnet_root_dir/$table");

### untar 2nd dbnet_tar file
 
  system ("tar -xvf '$dbnet_root_dir/$sec_tar'");

### mv directories into $DBNROOT
 chdir ("$dbnet_root_dir/$dbndir");

 system ("mv -f $dbnet_root_dir/$dbndir/$bin $dbnet_root_dir");
 system ("mv -f $dbnet_root_dir/$dbndir/$cron $dbnet_root_dir");
 system ("mv -f $dbnet_root_dir/$dbndir/$packages $dbnet_root_dir");
 system ("mv -f $dbnet_root_dir/$dbndir/$table $dbnet_root_dir");
 system ("mv -f $dbnet_root_dir/$dbndir/$user $dbnet_root_dir");

##########
 # This should be split for each package in the future. RRomero. 09/15/00
 # I moved the building of the exec after the symlinks are made, to put the executables
 # files in the right directory (bin ->runtime/bin). Before the move, the executables were
 # in a bin directory on the desktop, and the link to the real "bin" directory (in the runtime)
 # couldn't be made. cathy 09/25/00
 #opendir(DIR, "$dbnet_root_dir/src") || warn "cannot opendir $src:$!";
 #@f = readdir (DIR);
 #closedir (DIR);
 #foreach $f (@f) {
 #  if ($f =~ /\.o$/) {
 #      unlink ("$dbnet_root_dir/src/$f");
 #                    }
 #                 }
 #       print "\nBuilding the executables for dbn_alert and dbn_bufr...\n";

# print "Building the executables for dbn_alert...\n";
# chdir ("$dbnet_root_dir/$packages/alert");
# system ("pwd");
# system ("make clean");
# system ("make");
# system ("make install");

# print "Building the executables for dbn_bufr...\n";
# chdir ("$dbnet_root_dir/$packages/bufr");
# system ("pwd");
# system ("make clean");
# system ("make");
# system ("make install");
##########

  chdir ("$dbnet_root_dir");
  system ("pwd");
  opendir (DIR, "$dbnet_root_dir/$newbin") || warn "cannot opendir $newbin:$!";
  @f= readdir (DIR);
  $os = $f[2];
  print "$os\n";

## mv IFSP_*  IFCP_* from bin.ifp/$os to DBNROOT
 chdir ("$dbnet_root_dir");
 system ("pwd");

# system ("ls $dbnet_root_dir/$newbin/$os");

 $prod_dir = "$dbnet_root_dir/$newbin/$os";
 opendir (DD, "$prod_dir") || die "cannot open $prod_dir:$!";
 @prod = readdir (DD);
 closedir (DD);
  foreach $p (@prod) { 
  if ($p =~  /IFCP/) {
     $ifc = $p;
     print "$ifc\n";
#     system ("pwd");
                     }
  elsif ($p =~ /IFSP/) {
     $ifs = $p;
      print "$ifs\n";
#      system ("pwd");
                       }
                   }
#  chdir ("$dbnet_root_dir");
  system ("mv -f '$prod_dir/$ifc'  '$bin'");
  system ("mv -f '$prod_dir/$ifs'  '$bin'");

### make symlinks
   chdir ("$dbnet_root_dir/$bin");
#
   $can = (eval {symlink ("$ifc", "IFCP") ;}, $@ eq "");
   $can = (eval {symlink ("$ifs", "IFSP") ;}, $@ eq "");

   if (-e "perl") {
      if (defined ($x = readlink ("perl")) && $x !~ /$perl/) {
       unlink ("perl") || warn "can't unlink perl.\n";
                                                             }
                  }
    $can = (eval {symlink ("$perl", "perl") ;}, $@ eq "");
    print "\n\n";

#### now all 'dbnet' is in dbnet-3.4j directory. we need to symlink runtime to dbnet-3.2
#### and also make symlinks to table, user, bin, cron

  chdir ("$dbnet_root_dir");
  $new_root_dir = dirname ($dbnet_root_dir);
  print $new_root_dir;

#### set $ENV{DBNROOT} and symlink runtime and dbnet-3.4
   $ENV{"DBNROOT"} = "$new_root_dir";

   chdir ("$new_root_dir");
   $can = (eval {symlink ("$dbndir", "runtime") ;}, $@ eq "");
   $can = (eval {symlink ("runtime/table", "table") ;}, $@ eq "");
   $can = (eval {symlink ("runtime/bin", "bin") ;}, $@ eq "");
   $can = (eval {symlink ("runtime/cron", "cron") ;}, $@ eq "");
   $can = (eval {symlink ("runtime/user", "user") ;}, $@ eq "");

 print "Building the executables for dbn_alert...\n";
 chdir ("$dbnet_root_dir/$packages/alert");
 system ("pwd");
 system ("make clean");
 system ("make");
 system ("make install");

print "\n\nBuilding the executables for dbn_bufr...\n";
 chdir ("$dbnet_root_dir/$packages/bufr");
 system ("pwd");
 system ("make clean");
 system ("make");
 system ("make install");

### what's the shell?
  $shell = $ENV{"SHELL"};
  print $shell, "\n";

### create startup file .profile
  chdir ("$new_root_dir");  
  if ($shell =~ /\/sh|ksh/) {
    dot_profile();
  }

  if ($shell =~ /bash/) {
    open (PROFILE, ">>.profile") || die "Cannot open .profile: $!";
    print PROFILE "export DBNROOT=$new_root_dir\n";
    close PROFILE;
  }

  if ($shell =~ /csh/) {
    dot_cshrc();
    dot_profile();
  }
###
sub dot_profile {
  open (NEWPROF, ">$newprof") || die "cannot create new startup file: $!";
  print NEWPROF "export DBNROOT=$new_root_dir\n";
  if (-e $prof) {
    open (PROF, "<$prof") || die "cannot open startup file: $!";
    while ($l = <PROF>){
      unless ($l =~  /DBNROOT/) {
        print NEWPROF $l;
      }
    }
  }
  close NEWPROF;
  close PROF;
  rename ("$newprof", "$prof");
}

###
sub dot_cshrc {
  open (NEWSTART, ">$newstart") || die "cannot create new startup file: $!";
  print NEWSTART "setenv DBNROOT $new_root_dir\n";
  if (-e $start) {
    open (START, "<$start") || die "cannot open startup file: $!";
    while ($l = <START>) {
      unless ($l =~  /DBNROOT/) {
        print NEWSTART $l;
      }
    }
  }
  close START;
  close NEWSTART;
  rename ("$newstart", "$start");
}

### create directories: data, err, log...

   mkdir ("data", 0755) || die "cannot mkdir data:$!";
   mkdir ("dbnet_que", 0755) || die "cannot mkdir dbnet_que:$!";
   mkdir ("dbnet_que/enque", 0755) || die "cannot mkdir dbnet_que/enque:$!";
   mkdir ("err", 0755) || die "cannot mkdir err:$!";
   mkdir ("foreign", 0755) || die "cannot mkdir foreign:$!";
   mkdir ("log", 0755) || die "cannot mkdir log:$!";
   mkdir ("pending", 0755) || die "cannot mkdir pending:$!";
   mkdir ("tmp", 0755) || die "cannot mkdir tmp:$!";

system ("pwd");
   use vars '$can';


###set config file
   chdir ("$new_root_dir");
   $config = "$table/dbn_config";
   $newconf = "new_dbn_config";
   open (CONF, "<$config") || die "cannot open config file:$!";
   open (NEWCONF, ">$newconf") || die "cannot open new config file:$!";
   while ($_ = <CONF>) {
     if ($_ !~ /^\$dbnet_root_dir\s*\=/) {
        print NEWCONF $_;
                                                                       }
     else {
        $newline = "\$dbnet_root_dir=\"$new_root_dir\";";
        s/$_/$newline/;
        print NEWCONF $newline, "\n";
          }
                       }

    rename ("new_dbn_config", "$table/dbn_config") || die "can't rename new_dbn_config to dbn_config:$!";

    chdir ("$new_root_dir");

## go to bin dir and change the first line in all *.pl script into
## $new_root_dir/bin/perl

   opendir (DIR, "$bin") || die "cannot open bin";
   @script = readdir (DIR);
   close (DIR);
   foreach $script (@script) {
     if ($script !~ /^\./ && $script =~ /pl$/ && $script !~ /(chat2)|(util)|(file_scan)|(ftp\.pl)/) {
       print $script, "\n";
       open (PROG, "<$bin/$script" ) || warn "cannot open $script:$!";
       open (NEWP, ">$newprog") || warn "cannot create new file:$!";
       print NEWP "\#\!$new_root_dir/$bin/perl\n";
       while ($l = <PROG>) {
         if ($l =~ /^\#\!/ || $l =~ /^eval.*\'$/  || $l =~ /\s*if\s+0\;$/ ) {
         }
         else {
           print NEWP $l;
         }
       }
       close PROG;
       close NEWP;
       system ("chmod 750 $newprog");
       rename ("$newprog", "$bin/$script") || die "can't rename to $script:$!";
     }
   }


##cleanlist
  print " ...configuring the cleanlist...\n";
  open (NEWCL, ">$newprog") || warn "cannot create new file:$!";
     print NEWCL "$new_root_dir/log\tdbnet\\.log\\.\\d\{8\}\t0\t4\n";
     print NEWCL "$new_root_dir/log\tIFS\\.log\\.\\d\{8\}\t0\t4\n";
     print NEWCL "$new_root_dir/log\tdbn_admin\\.log\\.\\d\{8\}\t0\t4\n";
     print NEWCL "$new_root_dir/err\t\.\*\t0\t4\n";
     print NEWCL "$new_root_dir/data\t\.\*\t15\t12\n";
     print NEWCL "$new_root_dir/dbnet_que\t\\d\{12\}\t16\t48\n";
     print NEWCL "$new_root_dir/tmp\tDESEG\.X224\t0\t32\n";

 rename ("$newprog", "$new_root_dir/table/cleanlist") || die "cannot configure cleanist:$!";

###
  print "\n\n";
  print "DBNet is successfully installed.\n";
  print "Please, logout and re-logon, to allow the environment variable DBNROOT to be set.\n";



               }
